n = 40;
normNoise = 0.01;
[A,b,x] = ilaplace(n);
b = A*x;

[U,S,V] = svd(A);

function f = f(S, bt, normNoise, nu)
    [n,m] = size(S);
    f = 0;
    for k = 1:n
        f = f + bt(k)^2 / (1 + nu * S(k,k)^2)^2;
    endfor
    f = f - normNoise^2;
endfunction
        
function fprime = fprime(S, bt, normNoise, nu)
    [n,m] = size(S);
    fprime = 0;
    for k = 1:n
        fprime = fprime - 2*bt(k)^2 * S(k,k)^2 / (1 + nu * S(k,k)^2)^3;
    endfor
endfunction

for times = 1:100
    % generate error vector
    e = rand(n,1);
    e = e / norm(e) * normNoise;
    
    newB = b + e;
    
    % find mu
    bt = U'*newB;
    t     = -1;
    tnext = 1e-5;
    
    while (tnext > t)
        t = tnext;
        tnext = t - f(S,bt,normNoise, t) / fprime(S,bt,normNoise, t);
    endwhile
    
    mu = 1 / t;
    
    Snew = zeros(n,n);
    for k = 1:n
        Snew(k,k) = S(k,k)^2;
        if (Snew(k,k) < mu)
            Snew(k,k) = mu;
        endif
    endfor
    
    SnewInv = zeros(n,n);
    for k = 1:n
        SnewInv(k,k) = 1 / Snew(k,k);
    endfor
    
    xLothar = V*SnewInv*S*bt;
    
    Stik = zeros(n,n);
    for k = 1:n
        Stik(k,k) = 1 / (mu + S(k,k)^2);
    endfor

    xTikhonov = V*Stik*S*bt;

    times
    printf("Lothar\n")
    norm(x - xLothar)
    printf("Tikhonov\n")
    norm(x - xTikhonov)
end
